<?php

require('init.php');
require('xml.php');
require('geo.php');
date_default_timezone_set('UTC');

//$USE_SOAP_DATA = true;
$USE_SOAP_DATA = false;



$currentReleaseVersion = 0.2;

if (!isset($_REQUEST['version']) || ((float)$_REQUEST['version'] < $currentReleaseVersion)) {
    $AIXM_data['message'] = "Your application is outdated. Please download new version.";
}

$timestamp_start = (isset($_REQUEST['bts'])) ? (int)$_REQUEST['bts'] : mktime(0,0,0,1,1,2014);
$timestamp_end = (isset($_REQUEST['ets'])) ? (int)$_REQUEST['ets'] : ($timestamp_start+86400); 



if ($USE_SOAP_DATA) { // stazeni dat ze artisysu / soap rozhrani


try {

  $client = new SoapClient(
    "export.wsdl",
    array(
      'local_cert' => 'origin.pem', 
      'trace' => 1,
    )
  );

//  echo "<pre>".print_r($client->__getFunctions(), true)."</pre>";


$pipe_data = array(
  'trajectory' => array(),
  'radius' => 5000
);

if (isset($_REQUEST['pipe'])) {
  $pipe_request = json_decode($_REQUEST['pipe'], true);
  foreach ($pipe_request  as $pt) {
    array_push($pipe_data['trajectory'], array('point' => array('@latitude' => $pt['lat'], '@longitude' => $pt['lon'])));
  }
}

//$today_timestamp = ((int)(time()/86400))*86400;
//$timestamp_start = $today_timestamp;
//$timestamp_end = $today_timestamp+86400;


//$timestamp_start = mktime(0,0,0,1,1,2020); // h,m,s,M,D,Y
//$timestamp_end = mktime(0,0,0,1,1,2012); // h,m,s,M,D,Y

$isodate_start = date('Y-m-d\TH:i:s', $timestamp_start);
$isodate_end = date('Y-m-d\TH:i:s', $timestamp_end);
//$isodate_start = date('c', $timestamp_start);
//$isodate_end = date('c', $timestamp_end);


  if (isset($pipe_request) && isset($_REQUEST['bts'])) {
    $soapdata =   array(
     'parametrs' => array(
        'validTime' => array(
           'beginPosition' => $isodate_start,
           'endPosition' => $isodate_end,
        ),
        'pipe' => $pipe_data
      ),
    );
  } else if (isset($_REQUEST['bts'])) {
    $soapdata =   array(
     'parametrs' => array(
        'validTime' => array(
           'beginPosition' => $isodate_start,
           'endPosition' => $isodate_end,
        ),
      ),
    );
  } else {
    $soapdata =   array(
     'parametrs' => array(
/*
        'validTime' => array(
           'beginPosition' => '2015-01-01T00:00:00',
        ),
        'validTime' => array(
           'beginPosition' => $isodate_start,
           'endPosition' => $isodate_end,
        ),
        'circle' => array(
          'point' => array('@latitude' => 49.217343, '@longitude' => 16.567866),
          'radius' => '15000',
        ),

        'pipe' => array(
          'trajectory' => array(
              array('point' => array('@latitude' => 49.217343, '@longitude' => 16.567866)),
              array('point' => array('@latitude' => 50.084790, '@longitude' => 14.282633)),
              array('point' => array('@latitude' => 48.856614, '@longitude' => 2.352222)),
          ),
          'radius' => 9260,
        )
*/
      ),
    );
  }


//echo "<pre>".print_r($soapdata, true)."</pre>"; 
//echo "<pre>".htmlentities(array2xml($soapdata))."</pre>";

//exit();


  $soapvar = new SoapVar(
    array2xml($soapdata),
    XSD_ANYXML,
    'SOAPStruct',
    'http://www.artisys.eu/orion/export'
  );

if (isset($_REQUEST['baseline'])) {
  $baseline_xml = $client->GetBaseLine($soapvar);
  file_put_contents('GetBaseLine.xml', $baseline_xml);
} else {
  $baseline_xml = file_get_contents('GetBaseLine.xml');
}

$permdelta_xml = $client->GetPermDelta($soapvar);
file_put_contents('GetPermDelta.xml', $permdelta_xml);

$tempdelta_xml = $client->GetTempDelta($soapvar);
file_put_contents('GetTempDelta.xml', $tempdelta_xml);

//  $soapresponse = $client->GetSnapshot($soapvar);  file_put_contents('GetSnapshot.xml', $soapresponse);

//  file_put_contents('request.xml', $client->__getLastRequest());
//  file_put_contents('response.xml', $client->__getLastResponse());



} catch (Exception $e) {
  if (isset($_REQUEST['json'])) {
    throw new Exception ("Exception occured \n".print_r($e, true));
  }
  header('content-type: text/html');
  file_put_contents('request.xml', $client->__getLastRequest());
  file_put_contents('response.xml', $client->__getLastResponse());


  echo "<pre>".print_r($e, true)."</pre>";
  exit();
}


} else { //
  $baseline_xml = file_get_contents('GetSnapshot.xml');
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

$AIXM = array(
);
$AIXM_data = array(
);



$bad_data = array(); //array(14, 23, 25);
$all_times = array(); // see parse_xml_time()

$debug ="";
$data = xml2array($baseline_xml, 1,'attr');

if (isset($premdelta_xml)) {
  $permdelta = xml2array($permdelta_xml, 1,'attr');
  foreach (getSubtree($permdelta, 'message:AIXMBasicMessage') as $it) {
    array_push($data[0]['message:AIXMBasicMessage'], $it);
  }
}

if (isset($tempdelta_xml)) {
  $tempdelta = xml2array($tempdelta_xml, 1,'attr');
  foreach (getSubtree($tempdelta, 'message:AIXMBasicMessage') as $it) {
    array_push($data[0]['message:AIXMBasicMessage'], $it);
  }
}



function point_to_struct($arr) {

  $result = array();
  $result = explode(" ", $arr);
  if (count($result) > 2) {
   throw new Exception("unexpected size of data array ". print_r($arr, true));
  }
  return array('lat' => (float)$result[0], 'lon' => (float)$result[1]);

}

function posList_to_struct($arr) {

  $result = array();
//print_r($arr);
  $result = explode(" ", $arr);
  $arr = array();
  for ($i = 0; $i < count($result); $i += 2) {
    array_push($arr, array('lat' => (float)$result[$i], 'lon' => (float)$result[$i+1]));
  }

  return $arr;

}

$a = 0;

function makePointArrayAny($input) {
    global $NM_TO_M;

    $pts = array();

    foreach ($input as $type => $data) {
      if (isset($data['gml:GeodesicString'])){ 

        foreach ($data['gml:GeodesicString'] as $newp) {
          if (isset($newp['gml:pos'])) {
              array_push($pts, point_to_struct(ifSet($newp['gml:pos'])));
          } else if (isset($newp['gml:posList'])) {
            $newPointList = posList_to_struct(ifSet($newp['gml:posList']));
            foreach ($newPointList as $newPtItem) {
              array_push($pts, $newPtItem);
            }
          } else {
          }
        }

      } else if (isset($data['gml:ArcByCenterPoint'])) {
        $arcData = removeArrLvl($data['gml:ArcByCenterPoint']);
        $pos = ifSet($arcData['gml:pos']);

//echo "<pre>".print_r($arcData, true)."</pre>";

//        $radiusu = getSubtree($arcData['gml:radius'], '@uom');
//        $start_angle_u = getSubtree($arcData['gml:startAngle'], '@uom');
//        $end_angle_u = getSubtree($arcData['gml:endAngle'], '@uom');

        $radiusu = getSubtree($arcData['gml:radius'], '@uom');
        $radius = ifSet($arcData['gml:radius']);
        $radius = ($radiusu == 'M') ? $radius : ($radius * $NM_TO_M);
        $start_angle = ifSet($arcData['gml:startAngle'], 0);
        $end_angle = ifSet($arcData['gml:endAngle'], 360);

//echo $start_angle.' '.$end_angle."<br/>";
//if (abs($start_angle - 119) < 1) continue;//return $pts;
        $new_arr = insertMidArc(point_to_struct($pos), deg2rad($start_angle), deg2rad($end_angle), $start_angle < $end_angle , distToAngle($radius) );
//        $new_arr = insertMidArc(point_to_struct($pos), deg2rad($start_angle), deg2rad($end_angle), true, distToAngle($radius) );

        foreach ($new_arr as $it) {
            array_push($pts, $it);
        }

      } else if (isset($data['gml:CircleByCenterPoint'])) {

         $circleData = removeArrLvl($data['gml:CircleByCenterPoint']);
         $pos = ifSet($circleData['gml:pos']);


         $radiusu = getSubtree($circleData['gml:radius'], '@uom');
         $radius = ifSet($circleData['gml:radius']);
         $radius = ($radiusu == 'M') ? $radius : ($radius * $NM_TO_M);

         foreach (insertCircle(point_to_struct($pos), $radius) as $newp) {
           array_push($pts, $newp);
         }
      } else {
        echo "Error: makePointArrayAny: <pre>".print_r($data, true)."</pre>"; exit();
      }
    }
//    echo "<pre>".print_r($input, true)."</pre>";

    return $pts;

}


function parse_xml_time($str, $store = true) {
// '2013-05-30T00:00:00'
// $d = date_parse_from_format('Y-m-dTH:i:s',$t);
  global $all_times;
 if (preg_match("/(\d\d\d\d)\-(\d\d)-(\d\d)T(\d\d):(\d\d):(\d\d)/", $str, $match)) {
   $y = $match[1];
   $m = $match[2];
   $d = $match[3];
   $h = $match[4];
   $i = $match[5];
   $s = $match[6];
   $time = mktime($h, $i, $s, $m, $d, $y);
   if ($store) {
     array_push($all_times, $time);
   }
   return $time;
 }
 return '';

}


function trans_geom_surface($surface) {

  $horizontal = getSubtree(getSubtree(getSubtree(getSubtree(getSubtree(getSubtree($surface,'gml:PolygonPatch'),'gml:exterior'),'gml:Ring'),'gml:curveMember'),'gml:Curve'),'gml:segments');
  return ($horizontal !== "") ? makePointArrayAny($horizontal) : array();
}

function trans_geom_component($c) {
  $g = array();

  $g['op'] = ifSet($c['aixm:operation']);

  $airspaceVolume = getSubtree($c['aixm:theAirspaceVolume'], 'aixm:AirspaceVolume');

  $low = getSubtree($airspaceVolume, 'aixm:lowerLimit');
  $g['lowv'] = ifSet($low);
  $g['lowu'] = getSubtree($low, '@uom');
  $g['lowr'] = ifSet(getSubtree($airspaceVolume, 'aixm:lowerLimitReference'));

  $upper = getSubtree($airspaceVolume, 'aixm:upperLimit');
  $g['upv'] = ifSet($upper);
  $g['upu'] = getSubtree($upper, '@uom');
  $g['upr'] = ifSet(getSubtree($airspaceVolume, 'aixm:upperLimitReference'));

  $surface = getSubtree(getSubtree(getSubtree($airspaceVolume, 'aixm:horizontalProjection'), 'aixm:Surface'), 'gml:patches');
  $g['points'] = trans_geom_surface($surface);
  return $g;
}

$AIXMtypeArray = array(
  "BASELINE",
  "TEMPDELTA",
  "PERMDELTA",
);

function updateLocalStruct($itemName, $item) {
  global $AIXM, $AIXMtypeArray;

  $int = (isset($item['interpretation'])) ? $item['interpretation']: '';

  if (!in_array($int, $AIXMtypeArray)) {
    throw new Exception ("Unknown interpretation ".$itemName." " .print_r($item, true)." ". print_r($AIXMtypeArray, true));
  }

  if (!isset($AIXM[$int])) {
    $AIXM[$int] = array();
  }

  // pokud neexistuje v ostatnich typech tak vytvor prazne
  if (!isset($AIXM[$int][$itemName])) {
    foreach ($AIXMtypeArray as $intA) {
      $AIXM[$intA][$itemName] = array();
    }
  }

  array_push($AIXM[$int][$itemName], $item);


}

//echo "<pre>".print_r($data[0]['message:AIXMBasicMessage'], true)."</pre>";

$AIXMBasicMessage = getSubtree($data,'message:AIXMBasicMessage');
foreach ($AIXMBasicMessage as $AIXMBasicMessage) {
  foreach ($AIXMBasicMessage as $key => $hasMember) {
    if ($key == "message:hasMember") {
      foreach ($hasMember as $memberType => $member) {

  if (isset($member['aixm:AirportHeliport'])) {
    $airportHeliports = parseAIXMAirportHeliport($member['aixm:AirportHeliport']);
    foreach ($airportHeliports as $airportHeliport) {
      updateLocalStruct('airportHeliport', $airportHeliport);
    }
//echo "<pre>".print_r($member, true)."</pre>";
    continue;
  }
  if (isset($member['aixm:DesignatedPoint'])) {
//    updateLocalStruct('designatedPoint', parseDesignatedPoint($member['aixm:DesignatedPoint']));
    continue;
  }
  if (isset($member['aixm:RouteSegment'])) {
    continue;
  }

  if (isset($member['aixm:Navaid'])) {
    continue;
  }

  if (isset($member['aixm:VOR'])) {
    continue;
  }

  if (isset($member['aixm:DME'])) {
    continue;
  }

  if (isset($member['aixm:Route'])) {
    continue;
  }

  if (isset($member['aixm:NDB'])) {
    continue;
  }

  if (isset($member['aixm:Glidepath'])) {
    continue;
  }

  if (isset($member['aixm:Localizer'])) {
    continue;
  }

  if (isset($member['aixm:MarkerBeacon'])) {
    continue;
  }

  if (isset($member['aixm:Runway'])) {
    $a = parseAixmRunway($member['aixm:Runway']);
    updateLocalStruct('runway', $a);
    continue;
  }

  if (isset($member['aixm:RunwayDirection'])) {
    $a = parseAixmRunwayDirection($member['aixm:RunwayDirection']);
    updateLocalStruct('runwayDirection', $a);
    continue;
  }

  if (isset($member['aixm:RunwayCentrelinePoint'])) {
    continue;
  }

  if (isset($member['aixm:Event'])) {
    $a =  parseEvent($member['aixm:Event']);
    updateLocalStruct('event', $a);
    continue;
  }

  if (isset($member['aixm:VerticalStructure'])) {
    $a = parseVerticalStructure($member['aixm:VerticalStructure']);
    updateLocalStruct('verticalStructure', $a);
    continue;
  }

  if (isset($member['aixm:RadioCommunicationChannel'])) {
    continue;
  }
  if (isset($member['aixm:AirTrafficControlService'])) {
    continue;
  }
  if (isset($member['aixm:RunwayElement'])) {
    continue;
  }



  if (isset($member['aixm:Airspace'])) {
//    echo $key ."=> <pre>".print_r($member, true)."</pre>";
    $airspaces = parseAixmAirspace($member['aixm:Airspace']);
    foreach ($airspaces as $a) {
      updateLocalStruct('airspace', $a);
    }
    continue;
  }

  if (isset($member['@xlink:type'])) {
    continue;
  }

  echo $key ."=> <pre>".print_r($member, true)."</pre>";
  exit();



      }
    }
  }
}


/*
 * get xml subtree accroding to name
 */

function getSubtree($arr, $name) {
  foreach ($arr as $a => $b) {
    if (is_array($b)) {
      foreach ($b as $c => $d) {
        if ($c == $name) {
          return $d;
        }
      }
    }
  }
  return array();
}

/**
  * removes level of xml array (allows direct indexing)
  */

function removeArrLvl($arr) {
  $result = array();
  foreach ($arr as $a => $b) {
    foreach ($b as $c => $d) {
      $result[$c] = $d;
    }
  }
  return $result;
}

function ifSet($arr, $default = '') {
  return (isset($arr[0]) && !is_array($arr[0])) ? $arr[0] : $default;
}

function parseValidTime($timeSlice) {
  $timePeriod = getSubtree(getSubtree($timeSlice, 'aixm:validTime'), 'gml:TimePeriod');
  return array(
    'beginPosition' => parse_xml_time(ifSet(getSubtree($timePeriod,'gml:beginPosition'))),
    'endPosition' => parse_xml_time(ifSet(getSubtree($timePeriod,'gml:endPosition'))),
  );
}

function parseDesignatedPoint($arr) {
  $item = array();
  $item['id'] = ifSet(getSubtree($arr, 'gml:identifier'));
  $designatedPointTimeSlice = getSubtree(getSubtree($arr, 'aixm:timeSlice'), 'aixm:DesignatedPointTimeSlice');
  $item['interpretation'] = ifSet(getSubtree($designatedPointTimeSlice, 'aixm:interpretation'));
  $item['validTime'] = parseValidTime($designatedPointTimeSlice );
  list($lat, $lon)= explode(' ',ifSet(getSubtree(getSubtree(getSubtree($designatedPointTimeSlice,'aixm:location'),'aixm:Point'), 'gml:pos')));
  $item['designator'] = ifSet(getSubtree($designatedPointTimeSlice,'aixm:designator'));
  $item['type'] = ifSet(getSubtree($designatedPointTimeSlice,'aixm:type'));
  $item['lat'] = (float)$lat;
  $item['lon'] = (float)$lon;

//  echo "<pre>".print_r($designatedPointTimeSlice , true)."</pre>";
//  echo "<pre>".print_r($arr, true)."</pre>"; exit();
//  echo "<pre>".print_r($item, true)."</pre>"; exit();
  return $item;
}

function parseVerticalStructure($arr) {
  $item = array();

  $verticalStructureTimeSlice = getSubtree(getSubtree($arr, 'aixm:timeSlice'), 'aixm:VerticalStructureTimeSlice');

  $item['id'] = ifSet(getSubtree($arr, 'gml:identifier'));
  $item['validTime'] = parseValidTime($verticalStructureTimeSlice);
  $item['interpretation'] = ifSet(getSubtree($verticalStructureTimeSlice, 'aixm:interpretation'));
  $item['type'] = ifSet(getSubtree($verticalStructureTimeSlice, 'aixm:type'));
  $item['lighted'] = ifSet(getSubtree($verticalStructureTimeSlice, 'aixm:lighted'));
  $part = getSubtree($verticalStructureTimeSlice, 'aixm:part');
  $elevatedSurface = getSubtree(getSubtree(getSubtree($part, 
    'aixm:VerticalStructurePart'), 'aixm:horizontalProjection_surfaceExtent'),'aixm:ElevatedSurface');
  $surface = getSubtree($elevatedSurface, 'gml:polygonPatches');
  $item['geometry']['points'] = trans_geom_surface($surface);
  $item['geometry']['ele'] = ifSet(getSubtree($elevatedSurface, 'aixm:elevation'));
  $item['geometry']['eleu'] = getSubtree(getSubtree($elevatedSurface, 'aixm:elevation'), '@uom');

  return $item;
}

function parseEvent($arr) {
  $item = array();
  $item['id'] = ifSet(getSubtree($arr, 'gml:identifier'));
  $item['validTime'] = parseValidTime($arr);
  $item['interpretation'] = ifSet(getSubtree($arr, 'aixm:interpretation'));

  $notam = getSubtree(getSubtree($arr,'aixm:textNOTAM'), 'aixm:NOTAM');
  $item['NOTAM_number'] = ifSet(getSubtree($notam, 'number'));
  $item['NOTAM_type'] = ifSet(getSubtree($notam, 'type'));
  $item['NOTAM_text'] = ifSet(getSubtree($notam, 'text'));

  return $item;;
}

function parseAIXMRunwayDirection($arr) {
  $item = array();
  $item['id'] = ifSet(getSubtree($arr, 'gml:identifier'));

  $runwayDirectionTimeSlice = getSubtree(getSubtree($arr, 'aixm:timeSlice'), 'aixm:RunwayDirectionTimeSlice');
  $item['interpretation'] = ifSet(getSubtree($runwayDirectionTimeSlice , 'aixm:interpretation'));
  $item['validTime'] = parseValidTime($runwayDirectionTimeSlice);
  $item['designator'] = ifSet(getSubtree($runwayDirectionTimeSlice, 'aixm:designator'));
  $ref = getSubtree(getSubtree($runwayDirectionTimeSlice, 'aixm:usedRunway'), '@xlink:href');
  $item['usedRunway'] = (!is_array($ref) && (strlen($ref) > 9)) ? substr($ref, 9) : "";

  return $item;
}

function parseAIXMRunway($arr) {
  $item = array();
  $item['id'] = ifSet(getSubtree($arr, 'gml:identifier'));

  $runwayTimeSlice = getSubtree(getSubtree($arr, 'aixm:timeSlice'),'aixm:RunwayTimeSlice');
  $item['validTime'] = parseValidTime($runwayTimeSlice);
  $item['interpretation'] = ifSet(getSubtree($runwayTimeSlice, 'aixm:interpretation'));
  $item['designator'] = ifSet(getSubtree($runwayTimeSlice, 'aixm:designator'));
  $item['widthAccuracy'] = ifSet(getSubtree($runwayTimeSlice, 'aixm:widthAccuracy'));

  $ref = getSubtree(getSubtree($runwayTimeSlice, 'aixm:associatedAirportHeliport'),'@xlink:href');
  $item['associatedAirportHeliport'] = (!is_array($ref) && (strlen($ref) > 9)) ? substr($ref, 9) : "";

  return $item;
}



function parseAIXMAirportHeliport($arr) {
  $item = array();
  $airportHeliportTimeSlice = getSubtree(getSubtree($arr, 'aixm:timeSlice'),'aixm:AirportHeliportTimeSlice');
  $item['id'] = ifSet(getSubtree($arr, 'gml:identifier'));
  $item['type'] = ifSet(getSubtree($airportHeliportTimeSlice, 'aixm:type'));
  $item['designator'] = ifSet(getSubtree($airportHeliportTimeSlice, 'aixm:designator'));
  $item['name'] = ifSet(getSubtree($airportHeliportTimeSlice, 'aixm:name'));
  $item['interpretation'] = ifSet(getSubtree($airportHeliportTimeSlice, 'aixm:interpretation'));
  $item['validTime'] = parseValidTime($airportHeliportTimeSlice);
  $ElevatedPoint = getSubtree(getSubtree($airportHeliportTimeSlice, 'aixm:ARP'), 'aixm:ElevatedPoint');
  if (count($ElevatedPoint) > 0) {
    $pos = point_to_struct(ifSet(getSubtree($ElevatedPoint, 'gml:pos')));
    $item['lat'] = $pos['lat'];
    $item['lon'] = $pos['lon'];
  }
//  $item['mainDirection'] = 28;

  $item['ele'] = ifSet(getSubtree($ElevatedPoint, 'aixm:elevation'));
  $item['eleu'] = getSubtree(getSubtree($ElevatedPoint, 'aixm:elevation'), '@uom');

  if ($item['interpretation'] == "TEMPDELTA") {
    $activation = getSubtree(getSubtree($airportHeliportTimeSlice,'aixm:activation'), 'aixm:AirspaceActivation') ;
    $ref = getSubtree(getSubtree(getSubtree(getSubtree($airportHeliportTimeSlice, 'aixm:extension'), 'aixm:AirportHeliportExtension'), 'aixm:theEvent'), '@xlink:href');
    $item['event_ref'] = (!is_array($ref) && (strlen($ref) > 9)) ? substr($ref, 9) : "";;
  }

  return array($item);
}

function formatAirspaceDesignator($num) { // ocisluje pocasti TMA
  return ($num == 1) ? "" : " ".$num;
}

function parseAixmAirspace($arr) {
  $item = array();
    $airspaceTimeSlice = getSubtree(getSubtree($arr, 'aixm:timeSlice'),'aixm:AirspaceTimeSlice');
    
  $item['id'] = ifSet(getSubtree($arr, 'gml:identifier'));

  $item['type'] = ifSet(getSubtree($airspaceTimeSlice, 'aixm:type'));
  $item['interpretation'] = ifSet(getSubtree($airspaceTimeSlice, 'aixm:interpretation'));
  $designator = ifSet(getSubtree($airspaceTimeSlice, 'aixm:designator'));
  $item['name'] = ifSet(getSubtree($airspaceTimeSlice, 'aixm:name'));
  $timePeriod = getSubtree(getSubtree($airspaceTimeSlice, 'aixm:validTime'), 'gml:TimePeriod');
  $item['validTime']['beginPosition'] = parse_xml_time(ifSet(getSubtree($timePeriod,'gml:beginPosition')));
  $item['validTime']['endPosition'] = parse_xml_time(ifSet(getSubtree($timePeriod,'gml:endPosition')));


  if ($item['interpretation'] == 'TEMPDELTA') {
    $activation = getSubtree(getSubtree($airspaceTimeSlice,'aixm:activation'), 'aixm:AirspaceActivation') ;
    $item['activity'] = ifSet(getSubtree($activation, 'aixm:activity'));
    $item['status'] = ifSet(getSubtree($activation, 'aixm:status'));
  }
    $ref = getSubtree(getSubtree(getSubtree(getSubtree($airspaceTimeSlice, 'aixm:extension'), 'aixm:AirspaceExtension'), 'aixm:theEvent'), '@xlink:href');
    $item['event_ref'] = (!is_array($ref) && (strlen($ref) > 9)) ? substr($ref, 9) : "";;

//print_r($activation);

//echo $item['designator']."<br/>";
//if ($item['designator'] !== 'CTRLKTB') return;  // FIXME
//if ($item['designator'] !== 'TMALKTB') return;  // FIXME


//  $item['geometry'] = array('coords'=>array(), 'lowerLimit' =>'', 'upperLimit'=>'' );// = trans_geom_component();
  $items = array();
  $clone_id = 1;
//if ($item['interpretation']== 'TEMPDELTA') {

  $geometryComponentCount = 0;
  foreach ($airspaceTimeSlice as $key => $value) {
    if (isset($value['aixm:geometryComponent'])) { // muze se stat, ze je to TEMP DELTA a zmeni se jenom vyskova hranice (pak nervu celkoveho)

       $airspaceGeometryComponent = getSubtree($value['aixm:geometryComponent'], 'aixm:AirspaceGeometryComponent');
       $item['designator'] = $designator. formatAirspaceDesignator($clone_id);
       $clone_id++;
       $geom = trans_geom_component(removeArrLvl($airspaceGeometryComponent));
       // FIXME!!!
       if (count($geom['points']) > 0) { 
         $min_lat = 360;
         $min_lon = 360;
         $max_lat = -360; // inicializacni hodnota, tak musi byt strasne zaporna
         $max_lon = -360;
         foreach ($geom['points'] as $pt) {
            $min_lat = min($pt['lat'], $min_lat);
            $min_lon = min($pt['lon'], $min_lon);
            $max_lat = max($pt['lat'], $max_lat);
            $max_lon = max($pt['lon'], $max_lon);
         }
         $geom['min_lat'] = $min_lat;
         $geom['min_lon'] = $min_lon;
         $geom['max_lat'] = $max_lat;
         $geom['max_lon'] = $max_lon;
         $item['geometry'] = $geom;

         array_push($items, $item);
         $geometryComponentCount++;

       }
    }
  }
  if ($geometryComponentCount <= 0) {
     array_push($items, $item);
  }


//echo "<pre>".print_r($airspaceTimeSlice, true)."</pre>"; exit();
//} // if ['id']

  return $items;
}


function deep_copy($arr) {
  return $arr; // serialize/deserialize
}

function is_valid_for_query($new_item) {
  global $timestamp_start, $timestamp_end;

  $bp = (int)$new_item['validTime']['beginPosition'];
  $ep = (int)$new_item['validTime']['endPosition'];
  $ep = ($ep == 0) ? PHP_INT_MAX : $ep;

  if ($ep < $timestamp_start) {
    return false;
  }
  if ($bp > $timestamp_end) {
    return false;
  }

  return true;
}

// deep copy of baseline
$AIXM_data = deep_copy($AIXM['BASELINE']); 
foreach ($AIXM_data as $data_type => $data_content) {
  foreach ($data_content as $idx => $data_arr) {
    if (!isset($AIXM_data[$data_type][$idx]['tempdelta'])) {
      $AIXM_data[$data_type][$idx]['tempdelta'] = array();
    }
  }
}


// overwrite temp delta into AIXM_data
if (isset($AIXM['TEMPDELTA'])) {
  foreach ($AIXM['TEMPDELTA'] as $data_type => $data_content) {
    foreach ($data_content as $idx =>$item) {
      $found = false;
      foreach ($AIXM_data[$data_type] as $tidx => $titem) {
        if ($item['id'] == $titem['id']) {
          $found = true;
          if (is_valid_for_query($item)) {
            array_push($AIXM_data[$data_type][$tidx]['tempdelta'], $item);
          }

        }
      }
      if (!$found) {
        if (is_valid_for_query($item)) {
          array_push($AIXM_data[$data_type], $item);
        }
      }

    }
  }

/*

foreach ($AIXM['TEMPDELTA']['airspace'] as $d_idx => $d) {
  $as_ptr = -1;
  foreach ($AIXM_data['airspace'] as $as_idx => $as) {
    if ($d['id'] == $as['id']) {
      $as_ptr = $as_idx;
      break;
    }
  }
  $ev_ptr = -1;
  foreach ($AIXM_data['event'] as $ev_idx => $ev) {
    if ($ev['id'] == $d['event_ref']) {
      $ev_ptr = $ev_idx;
      $d['details'] = $AIXM_data['details'] = $ev;
      $AIXM_data['event'][$ev_idx]['found'] = true;
      break;
    }
  }
  if (($as_ptr >= 0) && ($ev_ptr >= 0)) {
    $act = array(
      'validTime' => $d['validTime'],
      'activity' => isset($d['activity']) ? $d['activity'] : '',
      'status' => isset($d['status']) ? $d['status']: '',
      'NOTAM_number' => $d['details']['NOTAM_number'],
      'NOTAM_type' => $d['details']['NOTAM_type'],
      'NOTAM_text' => $d['details']['NOTAM_text'],
    );
    array_push($AIXM_data['airspace'][$as_ptr]['events'], $act);
//    array_push($AIXM_data['airspace'][$as_ptr]['events'], $d);
//  } else {
//    echo "Not found: <pre>".print_r($d, true)."</pre>"; exit();
  }
//  echo "<pre>".print_r($d, true)."</pre>"; exit();
}

*/
} // isset($AIXM['TEMPDELTA'])



// presunuti do podstromu (nevim jestli to vlastne chci delat


if (isset($AIXM_data['runwayDirection'])) {
  foreach ($AIXM_data['runwayDirection'] as $rwd) {
    foreach ($AIXM_data['runway'] as $idx => $r) {
       if ($rwd['usedRunway'] == $r['id']) {
         if (!isset($r['runwayDirection']) || !is_array($r['runwayDirection'])) {
           $AIXM_data['runway'][$idx]['runwayDirection'] = array();
         } 
         array_push($AIXM_data['runway'][$idx]['runwayDirection'], $rwd);
       }
    } 
  }
}

if (isset($AIXM_data['runway'])) {
  foreach ($AIXM_data['runway'] as $rw) {
    foreach ($AIXM_data['airportHeliport'] as $idx => $aph) {
      if ($rw['associatedAirportHeliport'] == $aph['id']) {
        if (!isset($aph['runway']) || !is_array($aph['runway'])) {
          $AIXM_data['airportHeliport'][$idx]['runway'] = array();
        }
        array_push($AIXM_data['airportHeliport'][$idx]['runway'], $rw);

        // prechroupani smeru drahy
        if (!isset($aph['directions'])) {
           $AIXM_data['airportHeliport'][$idx]['directions'] = "";
        }

        foreach ($rw['runwayDirection'] as $rwd) {
          if (!isset($aph['mainDirection'])) {
            $AIXM_data['airportHeliport'][$idx]['mainDirection'] = (int)$rwd['designator'];
          }
          $AIXM_data['airportHeliport'][$idx]['directions'] .= $rwd['designator']. "/";
        }
        $AIXM_data['airportHeliport'][$idx]['directions'] = substr($AIXM_data['airportHeliport'][$idx]['directions'],0, -1). " ";

       }
    } 
  }
}


unset($AIXM_data['runwayDirection']);
unset($AIXM_data['runway']);



function airspace_color($type) {
   $array = array(
      'FIR' => "#000000",
      'TMA' => "#000080",
      'CTR' => "#000080",
      'R' => "#ff0000",
      'TRA' => "#ff0000",
      'TSA' => "#c4a000",
      'R' => "#ff0000",
      'D' => "#ff0000",
      'P' => "#ff0000",
      '' => "#000000",
   );

  if (!array_key_exists($type, $array)) {
    $type = '';
  }
  return $array[$type];
}



if (isset($_REQUEST['json'])) {
  header('content-type: application/json');
  echo json_encode($AIXM_data); 
  exit();
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// echo "<b>===</b><pre>".print_r($AIXM_data, true)."</pre>"; /* echo "<b>===</b><pre>".print_r($AIXM, true)."</pre>";   */ exit();


echo "<html>";
echo <<<EOF
<head>
  <title> </title>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <link rel="stylesheet" href="./style.css" type="text/css" />
</head>
<body>

<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
<script type="text/javascript">
  function initialize() {

    var myLatlng = new google.maps.LatLng(49.803575,15.475555);
    var myOptions = {
      zoom: 7,
      center: myLatlng,
      mapTypeId: google.maps.MapTypeId.ROADMAP,
    panControl: true,
    zoomControl: true,
    scaleControl: true,

    }


    var map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);


EOF;



$i=0;

if (isset($AIXM_data['airportHeliport'])) {
foreach ($AIXM_data['airportHeliport'] as $ah) {
    $lat = $ah['lat'];
    $lon = $ah['lon'];
    $title = $ah['designator'];

    $rot = isset($ah['mainDirection']) ? (int)$ah['mainDirection'] : 0;

    echo <<<EOF

    var marker_$i = new google.maps.Marker({
      position: new google.maps.LatLng($lat, $lon),
      map: map,
      title: "$title",
      icon: {
        url: './images/Airport$rot.png',
        anchor: new google.maps.Point(16,16),
      }
    });

EOF;
$i++;
}
}


if (isset($AIXM_data['designatedPoint'])) {
foreach ($AIXM_data['designatedPoint'] as $ah) {
    $lat = $ah['lat'];
    $lon = $ah['lon'];
    $title = $ah['designator'];


    echo <<<EOF

    var marker_$i = new google.maps.Marker({
      position: new google.maps.LatLng($lat, $lon),
      map: map,
      title: "$title",
      icon: {
        url: './images/Diamond_Blue.png',
        anchor: new google.maps.Point(8,8),
      }
    });

EOF;
$i++;
}
}

//foreach (array() as $e) {
if (isset($AIXM_data['verticalStructure'])) {
foreach ($AIXM_data['verticalStructure'] as $ao){
    echo "var coords_$i = [];\n";
    foreach ($ao['geometry']['points'] as $c) {
      $lat = $c['lat']; $lon = $c['lon'];
      echo "coords_$i.push(new google.maps.LatLng($lat, $lon));\n";
    }
 
    echo <<<EOF
    var polyline_$i = new google.maps.Polygon({
      paths: coords_$i,
      strokeColor: "#ff0000",
      strokeOpacity: 0.8,
      strokeWeight: 4,
      fillOpacity: 0.5,
      fillColor: "#0000ff",
      map: map
    });

EOF;
$i++;
}
}

$vertexHist = array();


//$debug = print_r($all_ao, true);
if (isset($AIXM_data['airspace'])) {
foreach ($AIXM_data['airspace'] as $ao) {

$vertexCount = 0;
//foreach (array() as $ao) {
      if (!isset($ao['geometry'])) {
        continue;
      }

  $bp = (int)$ao['validTime']['beginPosition'];
  $ep = (int)$ao['validTime']['endPosition'];
  $ep = ($ep == 0) ? PHP_INT_MAX : $ep;



  // activation === fillOpacity
  $fillOpacity = 0;
  if (count($ao['tempdelta']) > 0) {
    $fillOpacity = 0.5;
  }
/*
  foreach ($ao['events'] as $ev) {
    $bp = (int)$ev['validTime']['beginPosition'];
    $ep = (int)$ev['validTime']['endPosition']; 
    $ep = ($ep == 0) ? PHP_INT_MAX : $ep;
    if ($bp < $query_time && $query_time < $ep) {
      $fillOpacity = 0.5;
    }
  }
*/
   $color = airspace_color($ao['type']);

    echo "var coords_$i = [];\n";
    foreach ($ao['geometry']['points'] as $c) {
      $lat = $c['lat']; $lon = $c['lon'];
      echo "coords_$i.push(new google.maps.LatLng($lat, $lon));\n";
$vertexCount++;

    }
    echo <<<EOF
    var polyline_$i = new google.maps.Polygon({
      paths: coords_$i,
      strokeColor: "$color",
      strokeOpacity: 0.8,
      strokeWeight: 2,
      fillOpacity: $fillOpacity,
      fillColor: "$color",
      map: map
    });

EOF;
$i++;

$vertexHist[$vertexCount] = (isset($vertexHist[$vertexCount]) ? $vertexHist[$vertexCount] + 1 : 1);
} // foreach
} // isset

echo <<<EOF
  }
  
</script>
  <div id="map_canvas" style="width: 900px; height: 700px;"></div>
<script type="text/javascript">initialize()</script>

EOF;

$idx = isset($_REQUEST['i']) ? (int)$_REQUEST['i'] : 0;
echo "<a href=\"index.php?i=".($idx-1)."\">-1</a> ";
echo "<a href=\"index.php?i=".($idx+1)."\">+1</a> ";

echo "<br/> $debug";


  $format = 'Y-m-d H:i:s';
//  $format = 'r';

/*
  $hit_counter = $hit2_counter = $all_counter = 0;

foreach ($AIXM_data as $ao) {
  if (!isset($ao['geometry'])) {
    continue;
  }

  $tquery = $query_time;

  $tstart = $ao['validTime']['beginPosition'];
  $tend   = $ao['validTime']['endPosition'];
  $t2start = $item['featureLifetime']['beginPosition'];
  $t2end   = $item['featureLifetime']['endPosition'];

  $dstart = date($format, $tstart);
  $dend   = (PHP_INT_MAX != $tend) ? date($format, $tend) : "-";
  $dquery = date($format, $tquery);
  $d2start = date($format, $t2start);
  $d2end   = (PHP_INT_MAX != $t2end) ? date($format, $t2end) : "-";

  $hit = (($tstart < $tquery) && ($tquery < $tend));
  $hit2 = (($t2start < $tquery) && ($tquery < $t2end));
  $color = $hit ? "red" :"blue";
  $color2 = $hit2 ? "red" :"blue";


  $ok = ($tstart < $tend);
  $ok2 = ($t2start < $t2end);

  $hit_counter += $hit;
  $hit2_counter += $hit2;
  $all_counter++;


  echo $ao['designator']." ($ok; $ok2; $hit; $hit2) <br/>";
  echo "&nbsp;&nbsp; ";
//    echo "$tstart; ";
    echo "$t2start; ";
//    echo "$dstart; ";
    echo "$d2start";
    echo "<br/>";
  echo "&nbsp;&nbsp; ";
//    echo "<span style=\"color: $color\">$tquery</span>; ";
    echo "<span style=\"color: $color2\">$tquery</span>; ";
    echo "$dquery <br/>"; 
  echo "&nbsp;&nbsp; ";
//    echo "$tend; ";
    echo "$t2end; ";
//    echo "$dend; ";
    echo "$d2end";
  echo "<br/>";


}

echo " $hit_counter; $hit2_counter; $all_counter <br/>";
*/

$all_times = array_unique($all_times);
asort($all_times);

foreach ($all_times as $t) {

  echo date($format, $t)." -> <a href=\"index.php?bts=".($t+1)."\">open(".($t+1).")</a> <br/>\n";

//  echo date($format, $t)." -> <a href=\"index.php?t=".($t+1)."\">$t+1</a> <br/>\n";
}

if (isset ($AIXM_data['event'])) {
  echo "<table>";
  foreach ($AIXM_data['event'] as $e) {
    $bp = (int)$e['validTime']['beginPosition'];
    $ep = (int)$e['validTime']['endPosition']; 
    $ep = ($ep == 0) ? PHP_INT_MAX : $ep;


//foreach (array() as $e) {
    echo "<tr>";
    echo " <td>". (isset($e['found']) ? 1 : 0) ."</td>";
    echo " <td>". (is_int($e['validTime']['beginPosition']) ? date('r', $e['validTime']['beginPosition']) : '-') ."</td>";
    echo " <td>". (is_int($e['validTime']['endPosition']) ? date('r', $e['validTime']['endPosition']) : '-') ."</td>";
    echo " <td>". $e['NOTAM_type'] ."</td>";
    echo " <td>". $e['NOTAM_text'] ."</td>";
    echo "</tr>";

//  echo print_r($e, true);
  }
  echo "</table>";

}
/*
foreach ($AIXM_data['airspace'] as $ao) {
  if ($ao['designator'] == "LKAA") {
    file_put_contents('lkaa.json', json_encode($ao['geometry']['points']));
 print_r($ao['geometry']['points']);
  }
}
*/

ksort($vertexHist);
echo "<pre>".print_r($vertexHist, true)."</pre>";

?>